kbuild: deb-pkg: support DEB_BUILD_OPTIONS=parallel=N in debian/rules
[linux-block.git] / scripts / Makefile.package
CommitLineData
ec8f24b7 1# SPDX-License-Identifier: GPL-2.0-only
1da177e4 2# Makefile for the different targets used to generate full packages of a kernel
000ec95f
MY
3
4include $(srctree)/scripts/Kbuild.include
05e96e96 5include $(srctree)/scripts/Makefile.lib
1da177e4 6
e1287eb8 7KERNELPATH := kernel-$(subst -,_,$(KERNELRELEASE))
6615d6c3 8# Include only those top-level files that are needed by make, plus the GPL copy
a3c4d4ab 9TAR_CONTENT := Documentation LICENSES arch block certs crypto drivers fs \
df1f1ea9
PL
10 include init io_uring ipc kernel lib mm net rust \
11 samples scripts security sound tools usr virt \
f6e09b07 12 .config Makefile \
6615d6c3 13 Kbuild Kconfig COPYING $(wildcard localversion*)
1da177e4 14
26803821
RV
15quiet_cmd_src_tar = TAR $(2).tar.gz
16 cmd_src_tar = \
17if test "$(objtree)" != "$(srctree)"; then \
262dad68
MY
18 echo >&2; \
19 echo >&2 " ERROR:"; \
20 echo >&2 " Building source tarball is not possible outside the"; \
6fc91752 21 echo >&2 " kernel source tree. Don't set KBUILD_OUTPUT"; \
262dad68 22 echo >&2; \
26803821
RV
23 false; \
24fi ; \
e4a42c82 25tar -I $(KGZIP) -c $(RCS_TAR_IGNORE) -f $(2).tar.gz \
f6e09b07 26 --transform 's:^:$(2)/:S' $(TAR_CONTENT) $(3)
26803821 27
05e96e96
MY
28# Git
29# ---------------------------------------------------------------------------
7bf4582d 30
05e96e96 31filechk_HEAD = git -C $(srctree) rev-parse --verify HEAD 2>/dev/null
e0ca1674 32
05e96e96
MY
33.tmp_HEAD: check-git FORCE
34 $(call filechk,HEAD)
e0ca1674 35
05e96e96
MY
36PHONY += check-git
37check-git:
38 @if ! $(srctree)/scripts/check-git; then \
39 echo >&2 "error: creating source package requires git repository"; \
40 false; \
41 fi
e0ca1674 42
1d29b4c2
MY
43git-config-tar.gz = -c tar.tar.gz.command="$(KGZIP)"
44git-config-tar.bz2 = -c tar.tar.bz2.command="$(KBZIP2)"
45git-config-tar.lzma = -c tar.tar.lzma.command="$(LZMA)"
46git-config-tar.xz = -c tar.tar.xz.command="$(XZ)"
47git-config-tar.zst = -c tar.tar.zst.command="$(ZSTD)"
f8d94c4e 48
f6d82835 49quiet_cmd_archive = ARCHIVE $@
f8d94c4e 50 cmd_archive = git -C $(srctree) $(git-config-tar$(suffix $@)) archive \
9cedc5e8 51 --output=$$(realpath $@) $(archive-args)
f6d82835 52
1d29b4c2
MY
53suffix-gzip := .gz
54suffix-bzip2 := .bz2
55suffix-lzma := .lzma
56suffix-xz := .xz
57
7bf4582d
MY
58# Linux source tarball
59# ---------------------------------------------------------------------------
60
1d29b4c2 61linux-tarballs := $(addprefix linux, .tar.gz .tar.bz2 .tar.lzma .tar.xz)
f8d94c4e
MY
62
63targets += $(linux-tarballs)
9cedc5e8 64$(linux-tarballs): archive-args = --prefix=linux/ $$(cat $<)
f8d94c4e 65$(linux-tarballs): .tmp_HEAD FORCE
f6d82835 66 $(call if_changed,archive)
7bf4582d 67
37477496 68# rpm-pkg srcrpm-pkg binrpm-pkg
0131705d 69# ---------------------------------------------------------------------------
8818039f 70
37477496
MY
71quiet_cmd_mkspec = GEN $@
72 cmd_mkspec = $(srctree)/scripts/package/mkspec > $@
73
74kernel.spec: FORCE
75 $(call cmd,mkspec)
76
77PHONY += rpm-sources
78rpm-sources: linux.tar.gz
79 $(Q)mkdir -p rpmbuild/SOURCES
80 $(Q)ln -f linux.tar.gz rpmbuild/SOURCES/linux.tar.gz
81 $(Q)cp $(KCONFIG_CONFIG) rpmbuild/SOURCES/config
82 $(Q)$(srctree)/scripts/package/gen-diff-patch rpmbuild/SOURCES/diff.patch
83
84PHONY += rpm-pkg srcrpm-pkg binrpm-pkg
85
86rpm-pkg: private build-type := a
87srcrpm-pkg: private build-type := s
88binrpm-pkg: private build-type := b
89
90rpm-pkg srcrpm-pkg: rpm-sources
91rpm-pkg srcrpm-pkg binrpm-pkg: kernel.spec
92 +$(strip rpmbuild -b$(build-type) kernel.spec \
93 --define='_topdir $(abspath rpmbuild)' \
94 $(if $(filter a b, $(build-type)), \
783c55ae
MY
95 --target $(UTS_MACHINE)-linux --build-in-place --noprep --define='_smp_mflags %{nil}' \
96 $$(rpm -q rpm >/dev/null 2>&1 || echo --nodeps)) \
37477496
MY
97 $(if $(filter b, $(build-type)), \
98 --without devel) \
99 $(RPMOPTS))
af60e207 100
31f735c6
MY
101# deb-pkg srcdeb-pkg bindeb-pkg
102# ---------------------------------------------------------------------------
103
1d29b4c2
MY
104KDEB_SOURCE_COMPRESS ?= gzip
105
106supported-deb-source-compress := gzip bzip2 lzma xz
107
108PHONY += linux.tar.unsupported-deb-src-compress
109linux.tar.unsupported-deb-src-compress:
110 @echo "error: KDEB_SOURCE_COMPRESS=$(KDEB_SOURCE_COMPRESS) is not supported. The supported values are: $(supported-deb-source-compress)" >&2
111 @false
112
113debian-orig-suffix := \
114 $(strip $(if $(filter $(supported-deb-source-compress), $(KDEB_SOURCE_COMPRESS)), \
115 $(suffix-$(KDEB_SOURCE_COMPRESS)),.unsupported-deb-src-compress))
116
6eabebb1 117quiet_cmd_debianize = GEN $@
aa7d233f 118 cmd_debianize = $(srctree)/scripts/package/mkdebian $(mkdebian-opts)
6eabebb1
MY
119
120debian: FORCE
121 $(call cmd,debianize)
122
123PHONY += debian-orig
124debian-orig: private source = $(shell dpkg-parsechangelog -S Source)
125debian-orig: private version = $(shell dpkg-parsechangelog -S Version | sed 's/-[^-]*$$//')
1d29b4c2 126debian-orig: private orig-name = $(source)_$(version).orig.tar$(debian-orig-suffix)
aa7d233f 127debian-orig: mkdebian-opts = --need-source
1d29b4c2 128debian-orig: linux.tar$(debian-orig-suffix) debian
b44aa8c9
MY
129 $(Q)if [ "$(df --output=target .. 2>/dev/null)" = "$(df --output=target $< 2>/dev/null)" ]; then \
130 ln -f $< ../$(orig-name); \
131 else \
132 cp $< ../$(orig-name); \
133 fi
6eabebb1 134
31f735c6
MY
135KBUILD_PKG_ROOTCMD ?= 'fakeroot -u'
136
137PHONY += deb-pkg srcdeb-pkg bindeb-pkg
138
139deb-pkg: private build-type := source,binary
140srcdeb-pkg: private build-type := source
141bindeb-pkg: private build-type := binary
3716001b 142
31f735c6 143deb-pkg srcdeb-pkg: debian-orig
6eabebb1 144bindeb-pkg: debian
31f735c6
MY
145deb-pkg srcdeb-pkg bindeb-pkg:
146 +$(strip dpkg-buildpackage \
147 --build=$(build-type) --no-pre-clean --unsigned-changes \
148 $(if $(findstring source, $(build-type)), \
1d29b4c2 149 --unsigned-source --compression=$(KDEB_SOURCE_COMPRESS)) \
31f735c6 150 $(if $(findstring binary, $(build-type)), \
ed79c34d 151 --rules-file='$(MAKE) -f debian/rules' --jobs=1 -r$(KBUILD_PKG_ROOTCMD) -a$$(cat debian/arch), \
31f735c6
MY
152 --no-check-builddeps) \
153 $(DPKG_FLAGS))
b41d920a 154
5704d455
PP
155# snap-pkg
156# ---------------------------------------------------------------------------
6a4f6a26
MY
157PHONY += snap-pkg
158snap-pkg:
5704d455
PP
159 rm -rf $(objtree)/snap
160 mkdir $(objtree)/snap
161 $(MAKE) clean
162 $(call cmd,src_tar,$(KERNELPATH))
163 sed "s@KERNELRELEASE@$(KERNELRELEASE)@; \
164 s@SRCTREE@$(shell realpath $(KERNELPATH).tar.gz)@" \
165 $(srctree)/scripts/package/snapcraft.template > \
166 $(objtree)/snap/snapcraft.yaml
167 cd $(objtree)/snap && \
168 snapcraft --target-arch=$(UTS_MACHINE)
169
1fc90958 170# dir-pkg tar*-pkg - tarball targets
6d983fea 171# ---------------------------------------------------------------------------
1fc90958 172
1fc90958
MY
173tar-install: FORCE
174 $(Q)$(MAKE) -f $(srctree)/Makefile
175 +$(Q)$(srctree)/scripts/package/buildtar $@
176
3c65a270
MY
177compress-tar.gz = -I "$(KGZIP)"
178compress-tar.bz2 = -I "$(KBZIP2)"
179compress-tar.xz = -I "$(XZ)"
180compress-tar.zst = -I "$(ZSTD)"
181
05e96e96 182quiet_cmd_tar = TAR $@
3c65a270
MY
183 cmd_tar = cd $<; tar cf ../$@ $(compress-tar$(suffix $@)) --owner=root --group=root --sort=name *
184
185dir-tarballs := $(addprefix linux-$(KERNELRELEASE)-$(ARCH), .tar .tar.gz .tar.bz2 .tar.xz .tar.zst)
05e96e96 186
3c65a270 187$(dir-tarballs): tar-install
05e96e96
MY
188 $(call cmd,tar)
189
1fc90958
MY
190PHONY += dir-pkg
191dir-pkg: tar-install
192 @echo "Kernel tree successfully created in $<"
193
05e96e96
MY
194PHONY += tar-pkg
195tar-pkg: linux-$(KERNELRELEASE)-$(ARCH).tar
1fc90958
MY
196 @:
197
05e96e96
MY
198tar%-pkg: linux-$(KERNELRELEASE)-$(ARCH).tar.% FORCE
199 @:
6d983fea 200
e0ca1674 201# perf-tar*-src-pkg - generate a source tarball with perf source
8e5564e6
ACM
202# ---------------------------------------------------------------------------
203
05e96e96
MY
204.tmp_perf:
205 $(Q)mkdir .tmp_perf
e0ca1674 206
05e96e96
MY
207.tmp_perf/HEAD: .tmp_HEAD | .tmp_perf
208 $(call cmd,copy)
e0ca1674
MY
209
210quiet_cmd_perf_version_file = GEN $@
211 cmd_perf_version_file = cd $(srctree)/tools/perf; util/PERF-VERSION-GEN $(dir $(abspath $@))
212
05e96e96 213# PERF-VERSION-FILE and .tmp_HEAD are independent, but this avoids updating the
e0ca1674
MY
214# timestamp of PERF-VERSION-FILE.
215# The best is to fix tools/perf/util/PERF-VERSION-GEN.
05e96e96 216.tmp_perf/PERF-VERSION-FILE: .tmp_HEAD $(srctree)/tools/perf/util/PERF-VERSION-GEN | .tmp_perf
e0ca1674
MY
217 $(call cmd,perf_version_file)
218
f6d82835 219perf-archive-args = --add-file=$$(realpath $(word 2, $^)) \
05e96e96
MY
220 --add-file=$$(realpath $(word 3, $^)) \
221 $$(cat $(word 2, $^))^{tree} $$(cat $<)
e0ca1674 222
f8d94c4e
MY
223
224perf-tarballs := $(addprefix perf-$(KERNELVERSION), .tar .tar.gz .tar.bz2 .tar.xz .tar.zst)
225
226targets += $(perf-tarballs)
9cedc5e8 227$(perf-tarballs): archive-args = --prefix=perf-$(KERNELVERSION)/ $(perf-archive-args)
f8d94c4e 228$(perf-tarballs): tools/perf/MANIFEST .tmp_perf/HEAD .tmp_perf/PERF-VERSION-FILE FORCE
f6d82835 229 $(call if_changed,archive)
05e96e96
MY
230
231PHONY += perf-tar-src-pkg
232perf-tar-src-pkg: perf-$(KERNELVERSION).tar
233 @:
e0ca1674 234
05e96e96
MY
235perf-tar%-src-pkg: perf-$(KERNELVERSION).tar.% FORCE
236 @:
8e5564e6 237
1da177e4
LT
238# Help text displayed when executing 'make help'
239# ---------------------------------------------------------------------------
6a4f6a26
MY
240PHONY += help
241help:
8e5564e6 242 @echo ' rpm-pkg - Build both source and binary RPM kernel packages'
9c9b55a5 243 @echo ' srcrpm-pkg - Build only the source kernel RPM package'
3716001b
RV
244 @echo ' binrpm-pkg - Build only the binary kernel RPM package'
245 @echo ' deb-pkg - Build both source and binary deb kernel packages'
31f735c6 246 @echo ' srcdeb-pkg - Build only the source kernel deb package'
3716001b 247 @echo ' bindeb-pkg - Build only the binary kernel deb package'
a64c0440
GU
248 @echo ' snap-pkg - Build only the binary kernel snap package'
249 @echo ' (will connect to external hosts)'
af7db99a 250 @echo ' dir-pkg - Build the kernel as a plain directory structure'
8e5564e6
ACM
251 @echo ' tar-pkg - Build the kernel as an uncompressed tarball'
252 @echo ' targz-pkg - Build the kernel as a gzip compressed tarball'
253 @echo ' tarbz2-pkg - Build the kernel as a bzip2 compressed tarball'
9a17f400 254 @echo ' tarxz-pkg - Build the kernel as a xz compressed tarball'
88f5e1e6 255 @echo ' tarzst-pkg - Build the kernel as a zstd compressed tarball'
e0ca1674
MY
256 @echo ' perf-tar-src-pkg - Build the perf source tarball with no compression'
257 @echo ' perf-targz-src-pkg - Build the perf source tarball with gzip compression'
258 @echo ' perf-tarbz2-src-pkg - Build the perf source tarball with bz2 compression'
259 @echo ' perf-tarxz-src-pkg - Build the perf source tarball with xz compression'
260 @echo ' perf-tarzst-src-pkg - Build the perf source tarball with zst compression'
000ec95f 261
7bf4582d
MY
262PHONY += FORCE
263FORCE:
264
05e96e96
MY
265# Read all saved command lines and dependencies for the $(targets) we
266# may be building above, using $(if_changed{,_dep}). As an
267# optimization, we don't need to read them if the target does not
268# exist, we will rebuild anyway in that case.
269
270existing-targets := $(wildcard $(sort $(targets)))
271
272-include $(foreach f,$(existing-targets),$(dir $(f)).$(notdir $(f)).cmd)
273
000ec95f 274.PHONY: $(PHONY)